package jbiu.gui;

import java.awt.GridLayout;
import java.util.Iterator;

import javax.swing.JPanel;

import jbiu.model.JBIUModel;
import jbiu.model.UploadLinkCollector;

public class LinkCollectorPanel extends JPanel{

	private static final long serialVersionUID = 1L;
	
	private LinkPanel[] linkPanels; 
		
	public LinkCollectorPanel() {
		setLayout(new GridLayout(1,1));
	}
	
	public void clear() {
		for (LinkPanel p:linkPanels)
			p.clear();
	}
	
	public void displayLinks(UploadLinkCollector lc,Iterator<String> linkTypeNames, int linkTypesCount) {
		GridLayout gl=(GridLayout)getLayout();
		
		if (gl.getRows()!=linkTypesCount||linkPanels==null) {
			invalidate();
			removeAll();
			gl.setRows(linkTypesCount);
			linkPanels=new LinkPanel[linkTypesCount];
			
			for (int i=0;i<linkTypesCount;i++) {
				linkPanels[i]=new LinkPanel(lc, i, linkTypeNames.next(), JBIUModel.getModifiers());
				add(linkPanels[i]);
			}			
			validate();
		} else {
			for (int i=0;i<linkTypesCount;i++) {
				linkPanels[i].setLinkCollector(lc, i);
			}
		}
		
	}
}
