package jbiu.gui.settings;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.Collection;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;

import jbiu.gui.GUIConfigLoader2;
import jbiu.gui.GUIUploaderConfig;
import jbiu.gui.ReadTosActionListener;
import jbiu.init.JBIU;
import jbiu.model.UploaderConfig;

import settings.Settings;
import core.io.Application;
import gui.layout.percent2.APConstraint;
import gui.layout.percent2.AnchorPercentLayout;
import gui.resource.RMButton;
import gui.resource.ResourceManager;
import gui.settings.dialog.component.CheckboxSettingsComponent;
import gui.settings.dialog.group.SettingsComponentGroup;
import gui.settings.dialog.page.SettingsPage;

public class ToSAcceptSettingPage extends SettingsPage{

	private static final long serialVersionUID = -1577481282144654803L;

	public ToSAcceptSettingPage(String entry, Application app) {
		super(entry, app);
	}

	@Override
	protected void createComponentGroups(Settings settings, ResourceManager rm) {
		setLayoutMgr(1);
		addSettingsComponentGroup(new SettingsComponentGroup("ToS", rm) {
			
			private static final long serialVersionUID = 5904148881447719204L;

			@Override
			protected void createSettingsComponents(ResourceManager rm) {
				Collection<GUIUploaderConfig> cfgs=GUIConfigLoader2.getConfigs();
				JComboBox<GUIUploaderConfig> cbHosts=new JComboBox<>();
				setLayout(new AnchorPercentLayout());
				final DefaultComboBoxModel<GUIUploaderConfig> cbHostsModel= (DefaultComboBoxModel<GUIUploaderConfig>) cbHosts.getModel();
				for (GUIUploaderConfig cfg:cfgs){
					cbHostsModel.addElement(cfg);
				}
				final ReadTosActionListener readAl=new ReadTosActionListener();
				final AcceptToSComponent chkAcceptAlways=new AcceptToSComponent();
				
				cbHosts.addItemListener(new ItemListener() {
					
					@Override
					public void itemStateChanged(ItemEvent e) {
						
						if (e.getStateChange()==ItemEvent.SELECTED){
							GUIUploaderConfig cfg=(GUIUploaderConfig) cbHostsModel.getSelectedItem();
							readAl.setCfg(cfg.getUploaderConfig());
							chkAcceptAlways.setUploaderCfg(cfg.getUploaderConfig());
						}
					}
				});
				add(cbHosts,APConstraint.constraint().left(10).right(10).top(10));
				JButton bRead=new RMButton(rm,"readToS");
				bRead.addActionListener(readAl);
				add(bRead,APConstraint.constraint().left(10).right(10).topPercent(30));
				addSettingsComponent(chkAcceptAlways,APConstraint.constraint().left(10).right(10).topPercent(50));
				
				UploaderConfig cfg=cbHostsModel.getElementAt(0).getUploaderConfig();
				readAl.setCfg(cfg);
				chkAcceptAlways.setUploaderCfg(cfg);
			}
		});
	}
	
	private class AcceptToSComponent extends CheckboxSettingsComponent{

		
		
		public AcceptToSComponent() {
			super(null,JBIU.rm().getLocalizedString("alwaysAccept"));
			((JCheckBox) getComponent()).addActionListener(new ActionListener() {
				
				@Override
				public void actionPerformed(ActionEvent e) {
					saveSettings(settings);					
				}
			});
		}

		public void setUploaderCfg(UploaderConfig cfg) {
			settingsName=cfg.getInternalName()+"_acceptTos";
			loadSettings(settings);
		}
		
		@Override
		public void saveSettings(Settings s) {
			if (isSelected())
				super.saveSettings(s);
		}
	}

}
