package jbiu.model;

import java.io.IOException;
import java.util.List;
import java.util.Map;


import shoshone.httpclient.PostParameter;


public class TokenManager {
	
	private static char TOKEN_ID = '$';
	private static char STRING_CONCAT = '§';
	
	public static String resolve(String token,ULInfo ulInfo, UploaderConfig cfg, Map<String, String> inputTokens) throws IOException {
		String value=token;
		
		if (value == null) {
			throw new IOException();
		} else {
			while (value.length()>0&&  value.charAt(0)==TOKEN_ID) {
				if (value.equals(GlobalTokens.MIME)) {
					value= GlobalTokens.getMime(ulInfo.getFile());
				} else if (value.equals(GlobalTokens.EMPTY)) {
					value= GlobalTokens.getEmpty();	
				} else if (value.equals(GlobalTokens.FILE_NAME)) {
					value= ulInfo.getFileName();	
				} else if (value.startsWith("$HOST#")) {
					if (cfg!=null) {
						value=cfg.getToken(token);
					} else if (inputTokens!=null){
						value = inputTokens.get(token);
					} else {
						throw new IOException();
					}
				} else {
					if (ulInfo!=null) {
						value=ulInfo.getFileToken(token);
					} else if (inputTokens!=null){
						value = inputTokens.get(token);
					} else {
						throw new IOException();
					}
				}
//				} else if (value.startsWith(GlobalTokens.VAL_OF_COOKIE)) {
//					value=tokens.get(value.substring(token.indexOf('#')));
				
//				if (fileTokens!=null) {
//					v=fileTokens.get(value);
//				}
//				if (v!=null) {
//					value=v;
//					continue;
//				}
//				if (hostTokens!=null) {
//					v=hostTokens.get(value);
//				}
//				if (v!=null) {
//					value=v;
//					continue;
//				}
//				value=additionalTokens.get(value);
				if (value==null) {
					System.out.println(token);
					throw new IOException();
				}
			}
			return value;
		}
	}
	
	public static String resolveUrl(String url,ULInfo ulInfo, UploaderConfig cfg, Map<String, String> tokens) throws IOException {
		if (url.indexOf(STRING_CONCAT)>-1) {
			StringBuilder sb=new StringBuilder();
			String[] urlParts=url.split(Character.toString(STRING_CONCAT));
			
			for (String part:urlParts ) {
				sb.append(TokenManager.resolve(part,ulInfo,cfg,tokens));
			}
			return sb.toString();
		} else {
			return TokenManager.resolve(url, ulInfo, cfg, tokens);
		}
	}
	
	public static String resolveUrl(String url,Map<String, String> tokens) throws IOException {
		return resolveUrl(url, null, null, tokens);
	}
	
	public static List<PostParameter> resolvePostParameters(List<PostParameter> params,ULInfo ulInfo, UploaderConfig cfg, Map<String, String> additionalTokens) throws IOException {
		for (PostParameter p:params) {
			p.setValue(resolve(p.getValue(), ulInfo, cfg, additionalTokens));		
		}
		return params;
	}
}
